// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITITERATOR_H
#define GITITERATOR_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>
#include <unordered_map>

#include "async_baton.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"


using namespace node;
using namespace v8;

class GitIterator;

struct GitIteratorTraits {
  typedef GitIterator cppClass;
  typedef git_iterator cType;

  static const bool isDuplicable = false;
  static void duplicate(git_iterator **dest, git_iterator *src) {
     Nan::ThrowError("duplicate called on GitIterator which cannot be duplicated");
   }

  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_iterator *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitIterator : public
  NodeGitWrapper<GitIteratorTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitIteratorTraits>;
   public:
    static void InitializeComponent (v8::Local<v8::Object> target);

 

  private:
    GitIterator()
      : NodeGitWrapper<GitIteratorTraits>(
           "A new GitIterator cannot be instantiated."
       )
    {}
    GitIterator(git_iterator *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitIteratorTraits>(raw, selfFreeing, owner)
    {}
    ~GitIterator();
 };

#endif
